代码随想录算法训练营day 7 | Leetcode 454 383 15 18

Leetcode 454 四数相加Ⅱ

本题没有要求去重,可以用一个unordered_map先保留A+B,再枚举nums3和nums4,查询是否有(0-C-D)。

class Solution {
public:
    int fourSumCount(vector<int>& nums1, vector<int>& nums2, vector<int>& nums3, vector<int>& nums4) {
        unordered_map<int, int> cur;
        for(int A : nums1){
            for(int B : nums2){
                cur[A + B] ++;
            }
        }
        int cnt = 0;
        for(int C : nums3){
            for(int D : nums4){
                auto iter = cur.find(0 - C - D);
                if(iter != cur.end()){
                    cnt = cnt + iter -> second;
                }
            }
        }
        return cnt;
    }
};

Leetcode 383 赎金信

使用一个map记录magazine的字符出现次数,遍历ransomnote。官解用的数组,因为数组的实现要比map更高效。

class Solution {
public:
    bool canConstruct(string ransomNote, string magazine) {
        unordered_map<char, int> map;
        for(char s : magazine){
            map[s] ++;
        }
        for(char s : ransomNote){
            auto iter = map.find(s);
            if(iter == map.end()){
                return false;
            }else{
                iter -> second --;
                if(iter -> second == 0){
                    map.erase(s);
                }
            }
        }
        return true;
    }
};

Leetcode 15 三数之和

不管怎么样,还是要先对数组排序,然后注意题目中无重复的要求,需要特别操作。在遍历数组的前提下,使用双指针寻找(0-nums[i]),left指向i+1,right指向nums.size()-1,移动的条件为相同的值只用一次。

class Solution {
public:
    vector<vector<int>> threeSum(vector<int>& nums) {
        sort(nums.begin(), nums.end());
        int n =nums.size();
        vector<vector<int>> ans;
        for (int i = 0; i < n; i++){
            if(i > 0 && nums[i] == nums[i-1])
            continue;
            int k = n-1;
            int target = -nums[i];
            for(int j = i+1; j < n; j++){
                if(j > i+1 && nums[j] == nums[j-1])
                continue;
                while(j < k && nums[j] + nums[k] > target){
                    k--;
                }
                if (j == k)
                break;
                if(nums[i] + nums[j] + nums[k] == 0)
                ans.push_back({nums[i], nums[j], nums[k]});
            }
        }
        return ans;
    }
};

Leetcode 18 四数之和

和三数之和一样,只不过要再加一层循环,注意int类型数据溢出。

class Solution {
public:
    vector<vector<int>> fourSum(vector<int>& nums, int target) {
        sort(nums.begin(), nums.end());
        vector<vector<int>> res;
        for(int a = 0; a < nums.size(); a++){
            if(a > 0 && nums[a] == nums[a-1]){
                continue;
            }
            for(int b = a + 1; b < nums.size(); b++){
                if(b > a + 1 && nums[b] == nums[b - 1]){
                    continue;
                }
                int c = b + 1;
                int d = nums.size() - 1;
                while(c < d){
                    if((long) nums[a] + nums[b] + nums[c] + nums[d] < target){
                        c++;
                    }
                    else if((long) nums[a] + nums[b] + nums[c] + nums[d] > target){
                        d--;
                    }
                    else{
                        res.push_back(vector<int>{nums[a], nums[b], nums[c], nums[d]});
                        while(c < d && nums[c] == nums[c + 1]) {c++;}
                        while(c < d && nums[d] == nums[d - 1]) {d--;}
                        c++;
                        d--;
                    }
                }
            }
        }
        return res;
    }
};

  • 1
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
第二十二天的算法训练营主要涵盖了Leetcode题目中的三道题目,分别是Leetcode 28 "Find the Index of the First Occurrence in a String",Leetcode 977 "有序数组的平方",和Leetcode 209 "长度最小的子数组"。 首先是Leetcode 28题,题目要求在给定的字符串中找到第一个出现的字符的索引。思路是使用双指针来遍历字符串,一个指向字符串的开头,另一个指向字符串的结尾。通过比较两个指针所指向的字符是否相等来判断是否找到了第一个出现的字符。具体实现的代码如下: ```python def findIndex(self, s: str) -> int: left = 0 right = len(s) - 1 while left <= right: if s[left == s[right]: return left left += 1 right -= 1 return -1 ``` 接下来是Leetcode 977题,题目要求对给定的有序数组中的元素进行平方,并按照非递减的顺序返回结果。这里由于数组已经是有序的,所以可以使用双指针的方法来解决问题。一个指针指向数组的开头,另一个指针指向数组的末尾。通过比较两个指针所指向的元素的绝对值的大小来确定哪个元素的平方应该放在结果数组的末尾。具体实现的代码如下: ```python def sortedSquares(self, nums: List[int]) -> List[int]: left = 0 right = len(nums) - 1 ans = [] while left <= right: if abs(nums[left]) >= abs(nums[right]): ans.append(nums[left ** 2) left += 1 else: ans.append(nums[right ** 2) right -= 1 return ans[::-1] ``` 最后是Leetcode 209题,题目要求在给定的数组中找到长度最小的子数组,
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值